commit 1dbbfe23b15bfbab61d5fbcef9fbc193ee24dcb6
Author: Jerry DeLisle <jvdelisle@gcc.gnu.org>
Date:   Tue Dec 3 20:55:41 2024 -0800

    Fortran: Fix B64.0 formatted write output.
    
            PR fortran/117820
    
    libgfortran/ChangeLog:
    
            * io/write.c (write_b): Add test for zero needed by write_boz.
    
    gcc/testsuite/ChangeLog:
    
            * gfortran.dg/pr117820.f90: New test.
    
    (cherry picked from commit 7a92ba766815c9a6b73593967a26fdfbebfc7e69)

diff --git a/gcc/testsuite/gfortran.dg/pr117820.f90 b/gcc/testsuite/gfortran.dg/pr117820.f90
new file mode 100644
index 00000000000..59a4b363e05
--- /dev/null
+++ b/gcc/testsuite/gfortran.dg/pr117820.f90
@@ -0,0 +1,10 @@
+! { dg-do run }
+! See pr117820, original testcase provided by Malcolm Cohen.
+program test
+  integer(8) :: x
+  character(80) :: output
+  output = "garbage"
+  x = ibset (0_8, 63)
+  write(output, '("<",B64.0,">")') x
+  if (output .ne. "<1000000000000000000000000000000000000000000000000000000000000000>") stop 1
+end program
diff --git a/libgfortran/io/write.c b/libgfortran/io/write.c
index 91d1da2007a..9d0a0d6102b 100644
--- a/libgfortran/io/write.c
+++ b/libgfortran/io/write.c
@@ -1260,6 +1260,10 @@ write_b (st_parameter_dt *dtp, const fnode *f, const char *source, int len)
     {
       n = extract_uint (source, len);
       p = btoa (n, itoa_buf, sizeof (itoa_buf));
+
+      /* Test for zero. Needed by write_boz.  */
+      if (n != 0)
+	n = 1;
       write_boz (dtp, f, p, n, len);
     }
 }

